/*
** Module   :LINE.H
** Abstract :Class Line handles one line of editor
**
** Copyright (C) Sergey I. Yevtushenko
**
** Log: Wed  05/03/1997   	Updated to V0.5
*/

#ifndef  __LINE_H
#define  __LINE_H

class Line;
typedef Line* PLine;

class Line
{
    public:
        char *str;
        int buf_len;
        int known_len;

        int in_comment;
        int in_quote;

        Line();
        Line(char *);
        Line(PLine);

        ~Line();
        void expand_by(int len);
        void set(char *str);
        char * get_print(int start, char *buffer, int width);
        int ins_char(int chr, int pos);
        int del_char(int pos);
        int len();
        void touch();
        int char_at(int pos);
        int fchar_at(char *tmp, int pos) { return (pos < len()) ? tmp[pos]:0;}
        void build_print(char*);
        void xlat(char *cvt_tbl);
};

#endif //__LINE_H

