/*
** Module   :PALETTE.CPP
** Abstract :Color palette for all visible elements of editor
**
** Copyright (C) Sergey I. Yevtushenko
**
** Log: Sun  09/11/1997   	Updated to V0.1
*/

#include <common.h>
#include <editbox.h>
#include <_ctype.h>
#include <version.h>

Buffer* Clipboard = 0;

char *untitled=".";
char *statusline="L%3r:C%2c %h [%u%f]";
char StartupDir[FED_MAXPATH];
char Search[1025];
char Replace[1025];
char Flags[33];
char cName[1025];
char toupper_cvt_table[256];
char tolower_cvt_table[256];
char collate_cvt_table[256];
char _cFedPATH[FED_MAXPATH];

char *Screen;
char *AlignedBuffer;
int Rows;
int Cols;
int iTabWidth = 4;
int BufLen;
int iShape[2] = { 90, 0};
int iForce;
int iDefType = 0;
int iCtrlBrk = 0;
int iUpperStatus = 0;
int iNoEA = 0;
int iFileName = 1;

char app_pal[]=
{
    //CL_APPLICATION_START
    0x07,   //CL_DEFAULT
    0x70,   //CL_STATUSLINE

    //CL_DIALOG_START
    0x70,   //CL_DEFAULT
    0x70,   //CL_BORDER

    //CL_STEXT_START
    0x70,   //CL_DEFAULT
    0x7C,   //CL_HILITE

    //CL_EDITBOX_START
    0x08,   //CL_DEFAULT
    0x70,   //CL_SELECTION
    0x1B,   //CL_EOF
    0x06,   //CL_COMMENT
    0x07,   //CL_IDENT
    0x0E,   //CL_CONST
    0x0A,   //CL_PREPROC
    0x0C,   //CL_NUMBER
    0x0F,   //CL_STDWORD
    0x09,   //CL_SEMICOL
    0x0F,   //CL_FUNCTION
    0x0D,   //CL_XNUMBER

    //CL_EDITLINE_ACTIVE
    0x0F,   //CL_DEFAULT
    0x30,   //CL_SELECTION
    0x07,   //CL_EOF
    0x07,   //CL_COMMENT
    0x07,   //CL_IDENT
    0x07,   //CL_CONST
    0x07,   //CL_PREPROC
    0x07,   //CL_NUMBER
    0x07,   //CL_STDWORD
    0x07,   //CL_SEMICOL
    0x07,   //CL_FUNCTION
    0x07,   //CL_XNUMBER

    //CL_EDITLINE_INACTIVE
    0x1B,   //CL_DEFAULT
    0x3B,   //CL_SELECTION
    0x07,   //CL_EOF
    0x07,   //CL_COMMENT
    0x07,   //CL_IDENT
    0x07,   //CL_CONST
    0x07,   //CL_PREPROC
    0x07,   //CL_NUMBER
    0x07,   //CL_STDWORD
    0x07,   //CL_SEMICOL
    0x07,   //CL_FUNCTION
    0x07,   //CL_XNUMBER

    //CL_LISTBOX_START_ACTIVE
    0x30,   //CL_DEFAULT
    0x3B,   //CL_SELECTION
    0x07,   //CL_CURRENT
    0x0B,   //CL_CURRSEL

    //CL_LISTBOX_START_INACTIVE
    0x30,   //CL_DEFAULT
    0x3B,   //CL_SELECTION
    0x1B,   //CL_CURRENT
    0x1B,   //CL_CURRSEL

    //CL_MENU
    0x70,   //CL_DEFAULT
    0x7C,   //CL_SELECTION
    0x07,   //CL_CURRENT
    0x0C,   //CL_CURRSEL

    //CL_END_OF_PALETTE
    0
};

char ProgressBar[]="";

char _cZero[]="";

char* FileDialogNames[]=
{
    " File Open ",
    " File Save ",
    " File Save As ",
    _cZero
};

char *Yes_No[]=
{
    " ~Y~es",
    " ~N~o",
    " ~C~ancel ",
    0
};

char *help_text="No Help available";

stKeyMap AltKey[] =
{
    { 0x00, _cZero },
    { 0x1A, "Esc" },
    { 0x02, "1" },
    { 0x03, "2" },
    { 0x04, "3" },
    { 0x05, "4" },
    { 0x06, "5" },
    { 0x07, "6" },
    { 0x08, "7" },
    { 0x09, "8" },
    { 0x0A, "9" },
    { 0x01, "0" },
    { 0x38, "Minus" },
    { 0x19, "Equal" },
    { 0x0E, "Bksp" },
    { 0x48, "Tab" },
    { 0x3F, "Q" },
    { 0x4D, "W" },
    { 0x16, "E" },
    { 0x41, "R" },
    { 0x47, "T" },
    { 0x4F, "Y" },
    { 0x4A, "U" },
    { 0x30, "I" },
    { 0x3A, "O" },
    { 0x3B, "P" },
    { 0x35, "Lbracket" },
    { 0x42, "Rbracket" },
    { 0x18, "Enter" },
    { 0x00, _cZero },
    { 0x0B, "A" },
    { 0x44, "S" },
    { 0x12, "D" },
    { 0x1B, "F" },
    { 0x28, "G" },
    { 0x2E, "H" },
    { 0x32, "J" },
    { 0x33, "K" },
    { 0x34, "L" },
    { 0x45, "Semicolon" },
    { 0x40, "Quote" },
    { 0x49, "Tilde" },
    { 0x00, _cZero },
    { 0x0D, "BackSlash" },
    { 0x50, "Z" },
    { 0x4E, "X" },
    { 0x0F, "C" },
    { 0x4C, "V" },
    { 0x0C, "B" },
    { 0x39, "N" },
    { 0x37, "M" },
    { 0x11, "Comma" },
    { 0x3E, "Point" },
    { 0x14, "Div" },
    { 0x00, _cZero },
    { 0x2C, "GrMul" },
    { 0x00, _cZero },
    { 0x46, "Space" },
    { 0x00, _cZero },
    { 0x1C, "F1" },
    { 0x20, "F2" },
    { 0x21, "F3" },
    { 0x22, "F4" },
    { 0x23, "F5" },
    { 0x24, "F6" },
    { 0x25, "F7" },
    { 0x26, "F8" },
    { 0x27, "F9" },
    { 0x1D, "F10" },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x2F, "Home" },
    { 0x4B, "Up" },
    { 0x3D, "PgUp" },
    { 0x2B, "GrMinus" },
    { 0x36, "Left" },
    { 0x10, "Center" },
    { 0x43, "Right" },
    { 0x2D, "GrPlus" },
    { 0x17, "End" },
    { 0x15, "Down" },
    { 0x3C, "PgDown" },
    { 0x31, "Ins" },
    { 0x13, "Del" },
    { 0x1C, "F1" },
    { 0x20, "F2" },
    { 0x21, "F3" },
    { 0x22, "F4" },
    { 0x23, "F5" },
    { 0x24, "F6" },
    { 0x25, "F7" },
    { 0x26, "F8" },
    { 0x27, "F9" },
    { 0x1D, "F10" },
    { 0x1C, "F1" },
    { 0x20, "F2" },
    { 0x21, "F3" },
    { 0x22, "F4" },
    { 0x23, "F5" },
    { 0x24, "F6" },
    { 0x25, "F7" },
    { 0x26, "F8" },
    { 0x27, "F9" },
    { 0x1D, "F10" },
    { 0x1C, "F1" },
    { 0x20, "F2" },
    { 0x21, "F3" },
    { 0x22, "F4" },
    { 0x23, "F5" },
    { 0x24, "F6" },
    { 0x25, "F7" },
    { 0x26, "F8" },
    { 0x27, "F9" },
    { 0x1D, "F10" },
    { 0x00, _cZero },
    { 0x36, "Left" },
    { 0x43, "Right" },
    { 0x17, "End" },
    { 0x3C, "PgDown" },
    { 0x2F, "Home" },
    { 0x02, "1" },
    { 0x03, "2" },
    { 0x04, "3" },
    { 0x05, "4" },
    { 0x06, "5" },
    { 0x07, "6" },
    { 0x08, "7" },
    { 0x09, "8" },
    { 0x0A, "9" },
    { 0x01, "0" },
    { 0x38, "Minus" },
    { 0x19, "Equal" },
    { 0x3D, "PgUp" },
    { 0x1E, "F11" }, //Norm
    { 0x1F, "F12" },
    { 0x1E, "F11" }, //Shift
    { 0x1F, "F12" },
    { 0x1E, "F11" }, //Ctrl
    { 0x1F, "F12" },
    { 0x1E, "F11" }, //Alt
    { 0x1F, "F12" },
    { 0x4B, "Up" },
    { 0x2B, "GrMinus" },
    { 0x10, "Center" },
    { 0x2D, "GrPlus" },
    { 0x15, "Down" },
    { 0x31, "Ins" },
    { 0x13, "Del" },
    { 0x48, "Tab" },
    { 0x29, "GrDiv" },
    { 0x2C, "GrMul" },
    { 0x2F, "Home" },
    { 0x4B, "Up" },
    { 0x3D, "PgUp" },
    { 0x00, _cZero },
    { 0x36, "Left" },
    { 0x00, _cZero },
    { 0x43, "Right" },
    { 0x00, _cZero },
    { 0x17, "End" },
    { 0x15, "Down" },
    { 0x3C, "PgDown" },
    { 0x31, "Ins" },
    { 0x13, "Del" },
    { 0x29, "GrDiv" },
    { 0x00, _cZero },
    { 0x2A, "GrEnter" },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x2A, "GrEnter" },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero },
    { 0x00, _cZero }
};

int __r_ctype[]=
{
     0, IS_SP, IS_SP, IS_SP, IS_SP, IS_SP, IS_SP, IS_SP,
 IS_SP, IS_SP, IS_SP, IS_SP, IS_SP, IS_SP, IS_SP, IS_SP,
 IS_SP, IS_SP, IS_SP, IS_SP, IS_SP, IS_SP, IS_SP, IS_SP,
 IS_SP, IS_SP, IS_SP, IS_SP, IS_SP, IS_SP, IS_SP, IS_SP,
 IS_SP                          /*' ' - 0x20*/,
 IS_PU                          /*'!' - 0x21*/,
 IS_PU | IS_QU                  /*'"' - 0x22*/,
 IS_PU | IS_IS                  /*'#' - 0x23*/,
 IS_PU                          /*'$' - 0x24*/,
 IS_PU                          /*'%' - 0x25*/,
 IS_PU                          /*'&' - 0x26*/,
 IS_PU | IS_QU                  /*''' - 0x27*/,
 IS_PU                          /*'(' - 0x28*/,
 IS_PU                          /*')' - 0x29*/,
 IS_PU                          /*'*' - 0x2A*/,
 IS_PU                          /*'+' - 0x2B*/,
 IS_PU                          /*',' - 0x2C*/,
 IS_PU                          /*'-' - 0x2D*/,
 IS_PU                          /*'.' - 0x2E*/,
 IS_PU                          /*'/' - 0x2F*/,
 IS_DI | IS_XD | IS_HD          /*'0' - 0x30*/,
 IS_DI | IS_XD | IS_HD          /*'1' - 0x31*/,
 IS_DI | IS_XD | IS_HD          /*'2' - 0x32*/,
 IS_DI | IS_XD | IS_HD          /*'3' - 0x33*/,
 IS_DI | IS_XD | IS_HD          /*'4' - 0x34*/,
 IS_DI | IS_XD | IS_HD          /*'5' - 0x35*/,
 IS_DI | IS_XD | IS_HD          /*'6' - 0x36*/,
 IS_DI | IS_XD | IS_HD          /*'7' - 0x37*/,
 IS_DI | IS_XD | IS_HD          /*'8' - 0x38*/,
 IS_DI | IS_XD | IS_HD          /*'9' - 0x39*/,
 IS_PU                          /*':' - 0x3A*/,
 IS_PU | IS_SE                  /*';' - 0x3B*/,
 IS_PU                          /*'<' - 0x3C*/,
 IS_PU                          /*'=' - 0x3D*/,
 IS_PU                          /*'>' - 0x3E*/,
 IS_PU                          /*'?' - 0x3F*/,
 IS_PU                          /*'@' - 0x40*/,
 IS_AL | IS_XD | IS_HD | IS_IS  /*'A' - 0x41*/,
 IS_AL | IS_XD | IS_HD | IS_IS  /*'B' - 0x42*/,
 IS_AL | IS_XD | IS_HD | IS_IS  /*'C' - 0x43*/,
 IS_AL | IS_XD | IS_HD | IS_IS  /*'D' - 0x44*/,
 IS_AL | IS_XD | IS_HD | IS_IS  /*'E' - 0x45*/,
 IS_AL | IS_XD | IS_HD | IS_IS  /*'F' - 0x46*/,
 IS_AL                 | IS_IS  /*'G' - 0x47*/,
 IS_AL                 | IS_IS  /*'H' - 0x48*/,
 IS_AL                 | IS_IS  /*'I' - 0x49*/,
 IS_AL                 | IS_IS  /*'J' - 0x4A*/,
 IS_AL                 | IS_IS  /*'K' - 0x4B*/,
 IS_AL                 | IS_IS  /*'L' - 0x4C*/,
 IS_AL                 | IS_IS  /*'M' - 0x4D*/,
 IS_AL                 | IS_IS  /*'N' - 0x4E*/,
 IS_AL                 | IS_IS  /*'O' - 0x4F*/,
 IS_AL                 | IS_IS  /*'P' - 0x50*/,
 IS_AL                 | IS_IS  /*'Q' - 0x51*/,
 IS_AL                 | IS_IS  /*'R' - 0x52*/,
 IS_AL                 | IS_IS  /*'S' - 0x53*/,
 IS_AL                 | IS_IS  /*'T' - 0x54*/,
 IS_AL                 | IS_IS  /*'U' - 0x55*/,
 IS_AL                 | IS_IS  /*'V' - 0x56*/,
 IS_AL                 | IS_IS  /*'W' - 0x57*/,
 IS_AL                 | IS_IS  /*'X' - 0x58*/,
 IS_AL                 | IS_IS  /*'Y' - 0x59*/,
 IS_AL                 | IS_IS  /*'Z' - 0x5A*/,
 IS_PU                          /*'[' - 0x5B*/,
 IS_PU                          /*'\' - 0x5C*/,
 IS_PU                          /*']' - 0x5D*/,
 IS_PU                          /*'^' - 0x5E*/,
 IS_PU                 | IS_IS  /*'_' - 0x5F*/,
 IS_PU                          /*'`' - 0x60*/,
 IS_AL | IS_XD | IS_HD | IS_IS  /*'a' - 0x61*/,
 IS_AL | IS_XD | IS_HD | IS_IS  /*'b' - 0x62*/,
 IS_AL | IS_XD | IS_HD | IS_IS  /*'c' - 0x63*/,
 IS_AL | IS_XD | IS_HD | IS_IS  /*'d' - 0x64*/,
 IS_AL | IS_XD | IS_HD | IS_IS  /*'e' - 0x65*/,
 IS_AL | IS_XD | IS_HD | IS_IS  /*'f' - 0x66*/,
 IS_AL                 | IS_IS  /*'g' - 0x67*/,
 IS_AL                 | IS_IS  /*'h' - 0x68*/,
 IS_AL                 | IS_IS  /*'i' - 0x69*/,
 IS_AL                 | IS_IS  /*'j' - 0x6A*/,
 IS_AL                 | IS_IS  /*'k' - 0x6B*/,
 IS_AL                 | IS_IS  /*'l' - 0x6C*/,
 IS_AL                 | IS_IS  /*'m' - 0x6D*/,
 IS_AL                 | IS_IS  /*'n' - 0x6E*/,
 IS_AL                 | IS_IS  /*'o' - 0x6F*/,
 IS_AL                 | IS_IS  /*'p' - 0x70*/,
 IS_AL                 | IS_IS  /*'q' - 0x71*/,
 IS_AL                 | IS_IS  /*'r' - 0x72*/,
 IS_AL                 | IS_IS  /*'s' - 0x73*/,
 IS_AL                 | IS_IS  /*'t' - 0x74*/,
 IS_AL                 | IS_IS  /*'u' - 0x75*/,
 IS_AL                 | IS_IS  /*'v' - 0x76*/,
 IS_AL                 | IS_IS  /*'w' - 0x77*/,
 IS_AL                 | IS_IS  /*'x' - 0x78*/,
 IS_AL                 | IS_IS  /*'y' - 0x79*/,
 IS_AL                 | IS_IS  /*'z' - 0x7A*/,
 IS_PU                          /*'{' - 0x7B*/,
 IS_PU                          /*'|' - 0x7C*/,
 IS_PU                          /*'}' - 0x7D*/,
 IS_PU                          /*'~' - 0x7E*/,
 IS_SP | IS_PU                  /*' ' - 0x7F*/,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0
};

char *hi_names[]=
{
    "none",
    "C++",
    "REXX",
    "MAKE",
    "ASM",
    "HTML",
    "MAIL",
    "PASCAL",
    0
};

char *hi_names2[]=
{
    " ~N~o hiliting ",
    " ~C~++",
    " ~R~EXX",
    " ~M~AKE",
    " ~A~SM",
    " ~H~TML",
    " MA~I~L",
    " ~P~ASCAL",
    0
};


char *hi_map = _cZero;
int iDateFmt = 0;
int cDateSep = '/';
int iVSearch = 0;

