/*
** Module   :PARS_HTM.CPP
** Abstract :
**
** Copyright (C) Sergey I. Yevtushenko
**
** Log: Thu  09/04/1998 Created
**
*/

#include <common.h>
#include <parser.h>
#include <string.h>
#include <_ctype.h>
#include <version.h>

//----------------------------------------------------------------------
//
// Class Parser_HTML
//
//----------------------------------------------------------------------

int Parser_HTML::next_token()
{
    old_tok = tok;
    tok_len = 0;
    color = CL_DEFAULT;
    char *tmp = tok;

__quote:

    if(in_comment)
    {
        color = CL_COMMENT;

        for(;*tmp; tmp++)
        {
            if(tmp[0] == '-' && tmp[1] == '-' && tmp[2] == '>')
            {
                tmp += 3;
                in_comment = 0;
                break;
            }
        }

        return (tok_len = (tmp - tok));
    }

    if(in_quote)
    {
        //color = CL_IDENT;
        color = CL_FUNCTION;

        switch(*tmp)
        {
            case '\t':
            case ' ':
                for(++tmp; __issp(*tmp);)
                    tmp++;

                return (tok_len = (tmp - tok));

            case '"':
                for(++tmp; *tmp != '"' && *tmp;)
                    tmp++;

                if(*tmp == '"')
                    tmp++;

                color = CL_CONST;

                return (tok_len = (tmp - tok));

            case '>':
                in_quote = 0;
                break;

            default:
                if(__isis(*tmp))
                {
                    for(++tmp;__isic(*tmp);)
                        tmp++;

                    tok_len = (tmp - tok);

                    //color = CL_FUNCTION;

                    return tok_len;
                }
        }
    }
    else
    {
        for(;*tmp; tmp++)
        {
            if(*tmp == '<')
            {
                if(tmp[1] == '!' && tmp[2] == '-' && tmp[3] == '-')
                    in_comment = 1;
                else
                	in_quote = 1;

                if(tmp - tok)
                    break;

                if(in_comment)
                    tmp += 4;

                goto __quote;
            }
        }
        return (tok_len = (tmp - tok));
    }

    return (tok_len = 1);
}

