/*
** Module   :PARS_MK.CPP
** Abstract :
**
** Copyright (C) Sergey I. Yevtushenko
**
** Log: Thu  09/04/1998 Created
**
*/


#include <common.h>
#include <parser.h>
#include <string.h>
#include <_ctype.h>
#include <version.h>

//----------------------------------------------------------------------
//
// Class Parser_MAKE
//
//----------------------------------------------------------------------

int Parser_MAKE::next_token()
{
    old_tok = tok;
    tok_len = 0;
    color = CL_DEFAULT;
    char *tmp = tok;

    if(in_quote)
    {
        while(*tmp)
        {
            if(*tmp == in_quote)
            {
                tmp++;
                in_quote = 0;
                break;
            }
            tmp++;
        }
        color = CL_CONST;
        return (tok_len = (tmp - tok));
    }
    switch(*tmp)
    {
        case ' ':
        case '\t':
            for(++tmp; __issp(*tmp);)
                tmp++;
            return (tok_len = (tmp - tok));

        case '"':
        case '\'':

            if(!in_quote) /* continue previous line */
                in_quote = *tmp;
            else
            {
                if(*tmp != in_quote)
                {
                    tmp++;
                    return (tok_len = (tmp - tok));
                }
            }
            for(++tmp; *tmp != in_quote && *tmp;)
                tmp++;

            if(*tmp == in_quote)
            {
                tmp++;
                in_quote = 0;
            }
            color = CL_CONST;
            return (tok_len = (tmp - tok));

//        case '\\': /* Skip next character*/
//            tok_len = (tok[1]) ? 2:1;
//            return 2;

        case '#':
            while(*tmp)
                tmp++;

            color = CL_COMMENT;
            return (tok_len = (tmp - tok));

        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':

            while(__isdd(*tmp))
                tmp++;
            color = CL_NUMBER;
            return (tok_len = (tmp - tok));

        default:
            if(__isis(*tmp))
            {
                for(++tmp;__isic(*tmp);)
                    tmp++;

                tok_len = (tmp - tok);

                color = CL_IDENT;

                return tok_len;
            }
    }
    return (tok_len = 1);
}


